
%clear;

% The image should be saved as Windows .bmp 24-bit colour
% in any size

dot = imread('dotpic4.bmp','bmp');

dot_scale = 0.5; % 1=full size, 0.5=half size (for more precision when rotating...)

dot_size=size(dot)
dot_sizex=dot_size(1);
dot_sizey=dot_size(2);

dot_centerx = round(dot_sizex * 0.5)
dot_centery = round(dot_sizey * 0.5)

imagehandle = image (-dot_centerx, -dot_centery, dot)
% get (imagehandle)

picture = imread('pex.bmp','bmp');

picture_size=size(picture)
picture_sizex=picture_size(1);
picture_sizey=picture_size(2);

% A3-paper is 420mm wide and 297mm high
painting_dpi = 200;

%%%%
%painting_sizex_mm = 50;
%painting_sizey_mm = 40;
%painting_sizex = round(painting_sizex_mm * painting_dpi / 25.4); 
%painting_sizey = round(painting_sizey_mm * painting_dpi / 25.4); 
%%%%

painting_sizex_picturepixels = 30; % Number of dots to render
painting_sizey_picturepixels = 30;

painting_randomfactor_pixels = 0;

dots_distancex = round(dot_sizex*1)*dot_scale; % The distance between the dots
dots_distancey = round(dot_sizey*0.9)*dot_scale;
dots_zigzag = round(dots_distancex*0.5); % Every other line will be moved in the x-dir
dots_zigzag_lsb = 0;

painting_sizex = ceil((painting_sizex_picturepixels-1)/2) * dots_distancex + dot_sizex + painting_randomfactor_pixels
painting_sizey = ceil((painting_sizey_picturepixels-1)/2) * dots_distancey + dot_sizey + painting_randomfactor_pixels

picture_offsetx = 60;
picture_offsety = 60;

painting = ones(painting_sizey, painting_sizex, 3); % Now in colour!

rand('state',sum(100*clock)); % New seed to random function

for y = 1:2:(painting_sizey_picturepixels-2),
   for x = 1:2:(painting_sizex_picturepixels-2),
      
      % Get the colour of this pixel in the picture
      colour_r = double(picture(y + picture_offsety, x + picture_offsetx + dots_zigzag_lsb,1)) / 255;
      colour_g = double(picture(y + picture_offsety, x + picture_offsetx + dots_zigzag_lsb,2)) / 255;
      colour_b = double(picture(y + picture_offsety, x + picture_offsetx + dots_zigzag_lsb,3)) / 255
      
      rotation = rand(1) * 2 * pi;
      
      if (colour_r ~= 1) & (colour_g~=1) & (colour_b~=1),
         % Copy the dot to the painting with respect to the colour
         painting_x_center = 1 + x/2*dots_distancex + round(rand(1)*painting_randomfactor_pixels) + dots_zigzag_lsb*dots_zigzag + dot_centerx;
         painting_y_center = 1 + y/2*dots_distancey + round(rand(1)*painting_randomfactor_pixels) + dot_centery;
         
         for xx = round((dot_centerx - sqrt(dot_sizex^2 + dot_sizey^2))*dot_scale):1:round((dot_centerx + sqrt(dot_sizex^2 + dot_sizey^2))*dot_scale),
            for yy = round((dot_centery - sqrt(dot_sizex^2 + dot_sizey^2))*dot_scale):1:round((dot_centery + sqrt(dot_sizex^2 + dot_sizey^2))*dot_scale),
               painting_x = xx + painting_x_center;
               painting_y = yy + painting_y_center;
               
               dot_x = dot_centerx + (cos(rotation) * xx - sin(rotation) * yy)/dot_scale;
               dot_y = dot_centery + (sin(rotation) * xx + cos(rotation) * yy)/dot_scale;
               
               if (dot_x >= 1) & ( dot_x <= dot_sizex) & (dot_y>=1) & (dot_y<= dot_sizey),
                  dot_brigh = 1 * (1 - (dot_x - floor(dot_x))*(dot_y - floor(dot_y))); % The upper left dot-pixel impact on resulting pixel
                  dot_brigh = dot_brigh + (1 - (1-(dot_x - floor(dot_x)))*(dot_y - floor(dot_y))); % The upper right dot-pixel impact on resulting pixel
                  dot_brigh = dot_brigh + (1 - (dot_x - floor(dot_x))*(1-(dot_y - floor(dot_y)))); % The lower left dot-pixel impact on resulting pixel
                  dot_brigh = dot_brigh + (1 - (1-(dot_x - floor(dot_x)))*(1-(dot_y - floor(dot_y)))); % The lower right dot-pixel impact on resulting pixel
                  
                  dot_r = double(dot(floor(dot_x),floor(dot_y),1))./256 * (1 - (dot_x - floor(dot_x))*(dot_y - floor(dot_y))); % The upper left dot-pixel impact on resulting pixel
                  dot_r = dot_r + double(dot(floor(dot_x)+1,floor(dot_y),1))./256 * (1 - (1-(dot_x - floor(dot_x)))*(dot_y - floor(dot_y))); % The upper right dot-pixel impact on resulting pixel
                  dot_r = dot_r + double(dot(floor(dot_x),floor(dot_y)+1,1))./256 * (1 - (dot_x - floor(dot_x))*(1-(dot_y - floor(dot_y)))); % The lower left dot-pixel impact on resulting pixel
                  dot_r = dot_r + double(dot(floor(dot_x)+1,floor(dot_y)+1,1))./256 * (1 - (1-(dot_x - floor(dot_x)))*(1-(dot_y - floor(dot_y)))); % The lower right dot-pixel impact on resulting pixel
                  
                  dot_g = double(dot(floor(dot_x),floor(dot_y),2))./256 * (1 - (dot_x - floor(dot_x))*(dot_y - floor(dot_y))); % The upper left dot-pixel impact on resulting pixel
                  dot_g = dot_g + double(dot(floor(dot_x)+1,floor(dot_y),2))./256 * (1 - (1-(dot_x - floor(dot_x)))*(dot_y - floor(dot_y))); % The upper right dot-pixel impact on resulting pixel
                  dot_g = dot_g + double(dot(floor(dot_x),floor(dot_y)+1,2))./256 * (1 - (dot_x - floor(dot_x))*(1-(dot_y - floor(dot_y)))); % The lower left dot-pixel impact on resulting pixel
                  dot_g = dot_g + double(dot(floor(dot_x)+1,floor(dot_y)+1,2))./256 * (1 - (1-(dot_x - floor(dot_x)))*(1-(dot_y - floor(dot_y)))); % The lower right dot-pixel impact on resulting pixel
                  
                  dot_b = double(dot(floor(dot_x),floor(dot_y),3))./256 * (1 - (dot_x - floor(dot_x))*(dot_y - floor(dot_y))); % The upper left dot-pixel impact on resulting pixel
                  dot_b = dot_b + double(dot(floor(dot_x)+1,floor(dot_y),3))./256 * (1 - (1-(dot_x - floor(dot_x)))*(dot_y - floor(dot_y))); % The upper right dot-pixel impact on resulting pixel
                  dot_b = dot_b + double(dot(floor(dot_x),floor(dot_y)+1,3))./256 * (1 - (dot_x - floor(dot_x))*(1-(dot_y - floor(dot_y)))); % The lower left dot-pixel impact on resulting pixel
                  dot_b = dot_b + double(dot(floor(dot_x)+1,floor(dot_y)+1,3))./256 * (1 - (1-(dot_x - floor(dot_x)))*(1-(dot_y - floor(dot_y)))); % The lower right dot-pixel impact on resulting pixel
                  
					 painting(painting_y,painting_x,1) = (painting(painting_y,painting_x,1)) * (1-((1-dot_r/dot_brigh) * (1-colour_r)));
					 painting(painting_y,painting_x,2) = (painting(painting_y,painting_x,2)) * (1-((1-dot_g/dot_brigh) * (1-colour_g)));
					 painting(painting_y,painting_x,3) = (painting(painting_y,painting_x,3)) * (1-((1-dot_b/dot_brigh) * (1-colour_b)));
               end    
            end %for yy
         end %for xx   
         
      end %if (colour_r
   end %for x  
   if dots_zigzag_lsb == 1
      dots_zigzag_lsb = 0;
   else
      dots_zigzag_lsb = 1;
   end            
   
end %for y   

imwrite(painting,'painting2.bmp','bmp');




